Redmine - Defect #30434

Line height is too large when previewing files with syntax highlighting if the line terminators are
CRLF

2019-01-15 12:04 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Attachments Estimated time: 0.00 hour
Target version: 4.0.2

Resolution: Fixed Affected version: 4.0.0
Description

The height of some lines is too large if the line terminators of the file are CRLF. Only Redmine 4.0.0 is affected. No problem in prior
versions.

In the following screenshot, The height of line 1 and 2 is too large.

Bug #25 » hello-crlf.rb

Redmine Admin

puts "Hello world."
puts "Line terminaters are CRLF."

Related issues:
Related to Redmine - Feature #24681: Syntax highlighter: replace CodeRay with... Closed

Associated revisions

Revision 17847 - 2019-02-03 23:34 - Go MAEDA
Line height is too large when previewing files with syntax highlighting if the line terminators are CRLF (#30434).

Patch by Yuichi HARADA.

Revision 17848 - 2019-02-04 00:24 - Go MAEDA
Merged r17847 from trunk to 4.0-stable (#30434).

History

#1 - 2019-01-28 01:13 - Yuichi HARADA
- File 30434-remove-cr-chars.patch added

The rouge gem is splitting a character string with LF ("\n"). Therefore, output HTML containing CR ("\r"). As a result, we saw it with two rows of height.
| replaced CR with LF as follows.

diff --git a/lib/redmine/syntax_highlighting.rb b/lib/redmine/syntax_highlighting.rb
index e2d47£277..36612bc8c 100644
-—— a/lib/redmine/syntax_highlighting.rb
+++ b/lib/redmine/syntax_highlighting.rb
@@ -76,6 +76,7 @@ module Redmine
# Highlights +text+ as the content of +filename+
# Should not return line numbers nor outer pre tag
def highlight_by_filename (text, filename)

+ text.gsub! (/\r\n?/, "\n")
lexer =::Rouge::Lexer.guess_by_filename (filename)
formatter = ::Rouge::Formatters::HTML.new

::Rouge.highlight (text, lexer, CustomHTMLLinewise.new (formatter))
| attached a patch.

#2 - 2019-02-02 05:17 - Go MAEDA

- Target version set to 4.0.2

Confirmed that the patch fixes this issue. Setting the target version to 4.0.2.

#3 - 2019-02-02 06:11 - Go MAEDA
- File 30434-remove-cr-chars-v2.patch added
Slightly updated the patch.
e Fix that the first argument of highlight_by_filename is destructively changed by gsub!.

e Changed the test method name from test_syntax_highlight_should_remove_cr_chars to test_syntax_highlight_should_normalize_line_endings
because gsub(\r\n?/, "\n") not only simply removes CR characters but also replaces single CR with LF.

#4 - 2019-02-02 06:13 - Go MAEDA
- Related to Feature #24681: Syntax highlighter: replace CodeRay with Rouge added

#5 - 2019-02-02 10:41 - Marius BALTEANU

We should mark this fix as "workaround/quick fix" until rouge team fixes the problem on their side.

| found a PR which fixes this problem for other languages, but unfortunately, is not accepted yet. I've tested the solution proposed by that PR and it
works as expected, I'll try to make a new PR.

#6 - 2019-02-02 10:58 - Go MAEDA
Marius BALTEANU wrote:

We should mark this fix as "workaround/quick fix" until rouge team fixes the problem on their side.

Do you think it will be OK if we add a comment like "TODO: Delete the following line when Rouge is improved to handle CRLF properly"?

#7 - 2019-02-02 11:35 - Marius BALTEANU
Go MAEDA wrote:

Marius BALTEANU wrote:

We should mark this fix as "workaround/quick fix" until rouge team fixes the problem on their side.

Do you think it will be OK if we add a comment like "TODO: Delete the following line when Rouge is improved to handle CRLF properly"?

Yes, and you can point to Redmine issue number and the PR just opened by me to fix the issue: https:/github.com/jneen/rouge/pull/1078

#8 - 2019-02-03 07:24 - Go MAEDA
- File 30434-remove-cr-chars-v3.patch added

Added a comment as discussed in #30434#note-6 and #30434#note-7.

#9 - 2019-02-03 23:34 - Go MAEDA
- Status changed from New to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed. Thank you for fixing this issue.

#10 - 2019-02-04 00:24 - Go MAEDA

- Status changed from Resolved to Closed
